import es,popuplib,gamethread

admins = ["STEAM_0:0:3771609","STEAM_0:0:13654823"]
doorlist = {}

def door_fire(entity,func):
    userid = es.getuserid()
    tn = doorlist[int(entity)]["tn"]
    es.entitysetvalue(entity,"targetname","door_menu_tmp_%s"%entity)
    gamethread.delayed(0.1,es.fire,(userid,"door_menu_tmp_%s"%entity,func))
    gamethread.delayed(0.2,es.entitysetvalue,(entity,"targetname",tn))

def door_fire_all(func):
    for entity in doorlist: door_fire(entity,func)

def door_menu(userid,choice,popupname):
    if choice == 1: door_fire_all("open")
    elif choice == 2: door_fire_all("close")
    elif choice == 3: door_fire_all("lock")
    elif choice == 4: door_fire_all("unlock")
    elif choice == 5:
        door_fire_all("close")
        door_fire_all("lock")
    elif choice == 6:
        door_fire_all("unlock")
        door_fire_all("open")
    elif choice == 7: popuplib.send("door_broswer",userid)
    if choice != 10 and choice != 7: popuplib.send(popupname,userid)

def door_broswer(userid,choice,popupname):
    popuplib.send("door_broswer_%s"%choice,userid)

def door_broswer_door(userid,choice,popupname):
    entity = popupname.strip("door_broswer_")
    if choice == 1: door_fire(entity,"open")
    elif choice == 2: door_fire(entity,"close")
    elif choice == 3: door_fire(entity,"lock")
    elif choice == 4: door_fire(entity,"unlock")
    elif choice == 5:
        door_fire(entity,"close")
        door_fire(entity,"lock")
    elif choice == 6:
        door_fire(entity,"unlock")
        door_fire(entity,"open")
    if choice != 10: popuplib.send(popupname,userid)
    elif choice == 10: popuplib.send("door_broswer",userid)

def load():
    popup = popuplib.create("doormenu")
    popup.addline("<>Door||Menu<>")
    popup.addline("------------------------")
    popup.addline("->1. <>Open Doors<>")
    popup.addline("->2. <>Close Doors<>")
    popup.addline("->3. <>Lock Doors<>")
    popup.addline("->4. <>Unlock Doors<>")
    popup.addline("->5. <>Close/Lock Doors<>")
    popup.addline("->6. <>Unlock/Open Doors<>")
    popup.addline("->7. <>Door Broswer<>")
    popup.addline("-------------------------")
    popup.addline("->0. Exit")
    popup.menuselect = door_menu
    door_broswer_create()
    sv = es.ServerVar("mib_door_menu")
    sv.set("1.0")
    sv.makepublic()

def unload():
    popuplib.delete("doormenu")
    popuplib.delete("door_broswer")
    for entity in doorlist:
        if popuplib.exists("door_broswer_%s"%entity): popuplib.delete("door_broswer_%s"%entity)

def es_map_start(ev):
    door_broswer_create()

def door_broswer_create():
    popup = popuplib.easymenu("door_broswer",None,door_broswer)
    popup.settitle("<>Door Broswer||Menu<>")
    popup.submenu(10,"doormenu")
    for entity in es.createentitylist():
        cn = es.entitygetvalue(entity,"classname")
        tn = es.entitygetvalue(entity,"targetname")
        if cn == "func_door" or cn == "func_door_rotating":
            doorlist[entity] = {}
            doorlist[entity]["tn"] = tn
            if tn == "" or tn == " ": tn = "No Name"
            popup.addoption(entity," <>%s - %s<>"%(tn,entity))
            popup2 = popuplib.create("door_broswer_%s"%entity)
            popup2.addline("<>%s - %s||Menu<>"%(tn,entity))
            popup2.addline("------------------------")
            popup2.addline("->1. <>Open Door<>")
            popup2.addline("->2. <>Close Door<>")
            popup2.addline("->3. <>Lock Door<>")
            popup2.addline("->4. <>Unlock Door<>")
            popup2.addline("->5. <>Close/Lock Door<>")
            popup2.addline("->6. <>Unlock/Open Door<>")
            popup2.addline("-------------------------")
            popup2.addline("->0. Exit")
            popup2.menuselect = door_broswer_door

def player_say(ev):
    if ev["text"].lower() == "!doormenu":
        if ev["es_steamid"] in admins: popuplib.send("doormenu",ev["userid"])
        else: es.tell(ev["userid"],"#multi","\x05[Door Menu] You are not a door menu admin.")
